# plpgsql_sec

`plpgsql_sec` is a [PL/pgSQL][3] language variant that encrypts/decrypts
function bodies on the fly to hide their implementations. Encryption leverages
[`pgcrypto` module][4].

# INSTALL

```bash
PG_VER=17 # Set the desired PostgreSQL major version.
git clone git@github.com:cybertec-postgresql/plpgsql_sec.git
cd plpgsql_sec
git switch PG_${PG_VER}
make
make install
```

## Configure

* [Install](#install) the extension.
* Save encryption password into `$PGDATA/plpgsql_sec_passwd`.
* Invoke `CREATE EXTENSION plpgsql_sec;` as superuser.

# USAGE

To encrypt function bodies, use `plpgsql_sec` language with `CREATE FUNCTION`:

```
CREATE OR REPLACE FUNCTION func_name(...) ... LANGUAGE plpgsql_sec;
```

*Since the encryption key is stored in the data directory, function bodies
could potentially be decrypted by superusers, or by roles with `EXECUTE`
permission on the relevant [file access functions][1] or the appropriate
[predefined role][2].*

[1]: https://www.postgresql.org/docs/current/functions-admin.html#FUNCTIONS-ADMIN-GENFILE
[2]: https://www.postgresql.org/docs/current/predefined-roles.html
[3]: https://www.postgresql.org/docs/current/plpgsql.html
[4]: https://www.postgresql.org/docs/current/pgcrypto.html
